#include<iostream>
#include<fstream>
#include<string>

using namespace std;


struct Report
{
	int minAge;
	int maxAge;
	string gender;
	string race;

	void Display()
	{
		cout << race << '\t' << gender << '\t' << "Ages " << minAge << " to " << maxAge << endl;
	}
};

//user defined datatypes
struct Racer
{
	//attributes go here (aka. members, property)
	string lastName;
	string firstName;
	string raceName;
	string gender;
	int age;
	int bibNumber;
	string finishTime;
	int finishOrder;

	//constructor - special function called when the variable is created
	//no return value
	Racer()
	{
		lastName = "";
		firstName = "";
		raceName = "";
		gender = "";
		age = 0;
		bibNumber = 0;
		finishTime = "Did not finish";
		finishOrder = 0;
	}
	//method - function that is part of a user defined data type
	//aka member function
	void Display()
	{
		cout << "\t"<<lastName << ", " << firstName << "\t";
		cout <<  age << "\t";
		cout << bibNumber << "\t";
		cout << finishTime << endl;
	}

};


void setRacerFinish(Racer racers[], int bibNumber, int finishOrder, char finishTime[], int racerCount)
{
	bool racerFound = false;
	for(int i = 0; i < racerCount; i++)
	{
		if(racers[i].bibNumber == bibNumber)
		{
			racers[i].finishOrder = finishOrder;
			racers[i].finishTime = finishTime;
			racerFound = true;
		}
	}
	if(!racerFound)
	{
		cout << "Racer " << bibNumber << " was not in the racer file" << endl;
	}

}



void sortRacersByFinishOrder(Racer racers[],  int racerCount)
{
    bool sorted = false;
    for(int i = 0; i<racerCount && !sorted;i++)
    {
        sorted=true;
        for(int j=0; j<racerCount-i; j++)
        {
            if(racers[j].finishOrder > racers[j+1].finishOrder )
            {
				Racer temp = racers[j];
				racers[j] = racers[j+1];
				racers[j+1] = temp;
				sorted = false;
            }
        }
    }
}

bool readRacersFromFile(Racer racers[], int& racerCount)
{
	bool result = false;

	ifstream racersIn("racers.txt");

	char line[1000];

	if(!racersIn.fail() )
	{
		result = true;
		while(!racersIn.eof())
		{
			char word[100];

			racersIn.getline(word,1000,'\t');
			racers[racerCount].lastName = word;

			racersIn.getline(word,1000,'\t');
			racers[racerCount].firstName = word;

			racersIn.getline(word,1000,'\t');
			racers[racerCount].age = atoi(word);

			racersIn.getline(word,1000,'\t');
			racers[racerCount].gender = word;

			racersIn.getline(word,1000,'\t');
			racers[racerCount].raceName = word;

			racersIn.getline(word,1000);
			racers[racerCount].bibNumber = atoi(word);

			racerCount++;
		}
		racersIn.close();
	}
	return result;
}


bool readFinishOrderFromFile(Racer racers[], int racerCount)
{
	bool result = false;
	ifstream finishIn("finishOrder.txt");
	
	if(!finishIn.fail())
	{
		result = true;
		//read finish times
		char line[1000];
		
		//throw away the first line
		finishIn.getline(line,1000);
		
		int bibNumber;
		int finishOrder;
		char finishTime[10];
		while(!finishIn.eof())
		{
			finishIn >> bibNumber;
			finishIn >> finishOrder;
			finishIn >> finishTime;

			setRacerFinish(racers,bibNumber,finishOrder,finishTime,racerCount);
		}
		finishIn.close();
	}
	return result;
}

bool readRequestedReportsFromFile(Report reports[], int& reportCount)
{
	bool result = false;

	ifstream reportsIn("reports.txt");

	char line[1000];

	if(!reportsIn.fail() )
	{
		result = true;
		while(!reportsIn.eof())
		{
			char word[100];

			reportsIn >> reports[reportCount].minAge;
			reportsIn >> reports[reportCount].maxAge;
			
			//this is a hack to get rid of the tab char
//			char tab;
	//		reportsIn >> tab;

			reportsIn.getline(word,1000,'\t');
			reportsIn.getline(word,1000,'\t');
			reports[reportCount].gender = word;

			reportsIn.getline(word,1000);
			reports[reportCount].race = word;

			reportCount++;
		}
		reportsIn.close();
	}
	return result;
}

void reportResults(Racer racers[], int racerCount, Report reports[], int reportCount)
{
	for(int reportIndex = 0; reportIndex < reportCount; reportIndex++)
	{
		reports[reportIndex].Display();
		for(int racerIndex = 0; racerIndex < racerCount; racerIndex++)
		{
			if(reports[reportIndex].race == racers[racerIndex].raceName &&
				reports[reportIndex].gender == racers[racerIndex].gender &&
				racers[racerIndex].age >= reports[reportIndex].minAge  &&
				racers[racerIndex].age <= reports[reportIndex].maxAge &&
				racers[racerIndex].finishTime != "Did not finish")
			{
				racers[racerIndex].Display();
			}
		}
	}
}


void main()
{
	Racer racers[1000];
	Report reports[100];

	int racerCount = 0;
	int reportCount = 0;

	if(readRacersFromFile(racers, racerCount))
	{
		if(readFinishOrderFromFile(racers, racerCount))
		{
			sortRacersByFinishOrder(racers, racerCount);
			if(readRequestedReportsFromFile(reports, reportCount))
			{
				reportResults(racers, racerCount, reports, reportCount);
			}
		}

	}
}
